package nova.traffic.been;

import java.text.SimpleDateFormat;
import java.util.Date;

public class BrightnessByTimeParam {
	Date start;
	Date end;
	int brightness;
	public BrightnessByTimeParam(Date start, Date end, int brightness) {
		super();
		this.start = start;
		this.end = end;
		this.brightness = brightness;
	}
	
	public BrightnessByTimeParam() {
	}

	public Date getStart() {
		return start;
	}

	public void setStart(Date start) {
		this.start = start;
	}

	public Date getEnd() {
		return end;
	}

	public void setEnd(Date end) {
		this.end = end;
	}

	public int getBrightness() {
		return brightness;
	}

	public void setBrightness(int brightness) {
		this.brightness = brightness;
	}

	@Override
	public String toString() {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy.MM.dd HH:mm:ss");
		return "BrightnessByTimeParam [start=" + sdf.format(start) + ", end=" + sdf.format(end) + ", brightness=" + brightness + "]";
	}

}
