package nova.traffic.been;

import java.text.SimpleDateFormat;
import java.util.Date;

public class PlayByTimeParam {
	private Date start;
	private Date end;
	private int id;
	
	public PlayByTimeParam(Date start, Date end, int id) {
		this.start = start;
		this.end = end;
		this.id = id;
	}
	
	public PlayByTimeParam() {
	}
	
	public Date getStart() {
		return start;
	}
	public void setStart(Date start) {
		this.start = start;
	}
	public Date getEnd() {
		return end;
	}
	public void setEnd(Date end) {
		this.end = end;
	}
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}

	@Override
	public String toString() {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy.MM.dd HH:mm:ss");
		return "PlayByTimeParam [start=" + sdf.format(start) + ", end=" + sdf.format(end) + ", id=" + id + "]";
	}
	
}
